 SUBROUTINE local_getenv( var, ivar, value, ivalue )

!-------------------------------------------------------------------------------!
! Actual revisions:
! -----------------
! 
!
! Former revisions:
! -----------------
! $Log: local_getenv.f90,v $
! Revision 1.5  2003/05/09 14:37:07  raasch
! On the MUK cluster, only PE0 is able to read environment variables.
! Therefore, they have to be communicated via broadcast to the other PEs.
!
! Revision 1.4  2003/03/16 09:40:22  raasch
! Two underscores (_) are placed in front of all define-strings
!
! Revision 1.3  2001/01/22 07:23:55  raasch
! Comments translated into English
!
! Revision 1.2  1998/07/16 06:50:50  raasch
! cpp-Direktiven fuer t3ej2 und t3ej5 erweitert
!
! Revision 1.1  1997/08/11 06:21:01  raasch
! Initial revision
!
!
! Description:
! ------------
! Getting the values of environment-variabls (for different operating-systems)
!-------------------------------------------------------------------------------!

#if defined( __lcmuk )
    USE pegrid
#endif
    CHARACTER (LEN=*) ::  var, value
    INTEGER           ::  ivalue, ivar
#if defined( __t3eb ) || defined( __t3eh ) || defined( __t3ej2 ) || defined( __t3ej5 )
    INTEGER           ::  dummy
#endif
#if defined( __lcmuk )
    INTEGER            ::  i, ia(20)
#endif

#if defined( __t3eb ) || defined( __t3eh ) || defined( __t3ej2 ) || defined( __t3ej5 )
    CALL PXFGETENV( var(1:ivar), ivar, value, ivalue, dummy )
    IF ( ivalue == 0 )  value = ''
#else
    CALL GETENV( var(1:ivar), value )
    ivalue = LEN_TRIM( value )
#endif

#if defined( __lcmuk )  &&  defined( __parallel )
    ia = IACHAR( ' ' )
    IF ( myid == 0 )  THEN
       DO  i = 1, ivalue
          ia(i) = IACHAR( value(i:i) )
       ENDDO
    ENDIF
    CALL MPI_BCAST( ia(1), 20, MPI_INTEGER, 0, comm2d, ierr )
    DO  i = 1, 20
       IF ( ACHAR( ia(i) ) /= ' ' )  value(i:i) = ACHAR( ia(i) )
    ENDDO
    ivalue = LEN_TRIM( value )
#endif
 END SUBROUTINE local_getenv    
