 SUBROUTINE local_tremain_ini

!------------------------------------------------------------------------------!
! Actual revisions:
! -----------------
! 
!
! Former revisions:
! -----------------
! $Log: local_tremain_ini.f90,v $
! Revision 1.13  2007/02/11 13:07:03  raasch
! Allowed cpu limit is now read from file instead of reading the value from
! environment variable (see routine parin)
!
! Revision 1.12  2006/06/02 15:21:09  raasch
! Extended to TIT Sun Fire X4600 System (lctit)
!
! Revision 1.11  2003/05/09 14:40:20  raasch
! Time measurement on IBM is now done using function irtc, which allows correct
! measurements for jobs running over the 24:00 timeline
!
! Revision 1.10  2003/03/16 09:42:01  raasch
! Two underscores (_) are placed in front of all define-strings
!
! Revision 1.9  2002/12/19 15:50:31  raasch
! Measurements extended for IBM
!
! Revision 1.8  2001/03/30 07:35:16  raasch
! Translation of remaining German identifiers (variables, subroutines, etc.)
!
! Revision 1.7  2001/01/22 08:35:38  raasch
! Module test_variables removed
!
! Revision 1.5  1998/07/16 06:52:11  raasch
! cpp-Direktiven fuer t3ej2 und t3ej5 erweitert
!
! Revision 1.4  1998/07/06 12:19:21  raasch
! + USE test_variables
!
! Revision 1.3  1998/03/24 15:27:38  raasch
! Initialisierung auf t3eh ergaenzt
!
! Revision 1.2  1998/03/23 08:40:23  raasch
! Initialisierung auf vpp ergaenzt
!
! Revision 1.1  1998/03/18 20:15:05  raasch
! Initial revision
!
!
! Description:
! ------------
! Initialization of CPU-time measurements for different operating systems
!------------------------------------------------------------------------------!

    USE control_parameters
    USE cpulog

    IMPLICIT NONE

#if defined( __ibm )
    CHARACTER (LEN=10) ::  value_chr
    INTEGER            ::  idum
    INTEGER(8)         ::  IRTC
#elif defined( __lctit )
    CHARACTER (LEN=10) ::  value_chr
    INTEGER            ::  idum
    INTEGER            ::  count, count_rate
#endif


!
!-- Get initial wall clock time
#if defined( __ibm )

    initial_wallclock_time = IRTC( ) * 1E-9

#elif defined( __lctit )

    CALL SYSTEM_CLOCK( count, count_rate )
    initial_wallclock_time = REAL( count ) / REAL( count_rate )

#else
!
!-- So far, nothing is done on these machines
#endif


 END SUBROUTINE local_tremain_ini
